## viennacl 1.5.1

=== CMakeLists.txt ===
# Project setup
###############

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

project(ViennaCL)

SET(VIENNACL_SRC_DIST ON)


#
# User customizations if CMake does not find Boost or OpenCL
#

# Set boost path here if not found automatically by CMake
#SET(BOOST_ROOT "C:/Program\ Files\ (x86)/boost/boost_1_42")     # adjust this on Windows
#SET(BOOST_ROOT "/opt/local/include")                            # adjust this on MacOS or Linux

# For out-of-the-box support on MacOS:
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  INCLUDE_DIRECTORIES("/opt/local/include")
  set(CMAKE_EXE_LINKER_FLAGS "-framework OpenCL")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")


# Common options - There is usually no need to change anything below this line
################

set(VERSION_MAJOR 1)
set(VERSION_MINOR 5)
set(VERSION_PATCH 1)
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(ViennaCLCommon)

# Set release build:
IF(DEFINED CMAKE_BUILD_TYPE)
 SET (CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE})
ELSE()
 SET (CMAKE_BUILD_TYPE Release)
ENDIF()

# User options
##############

option(BUILD_DOXYGEN_DOCS "Build the Doxygen-generated API docs" ON)

option(BUILD_MANUAL "Build the PDF manual" ON)

mark_as_advanced(BUILD_DOXYGEN_DOCS BUILD_MANUAL)

# Find prerequisites
####################

if(BUILD_DOXYGEN_DOCS)
   find_package(Doxygen REQUIRED)
endif()

if(BUILD_MANUAL)
   find_package(LATEX REQUIRED)
endif()

# Compile options
#################

include_directories(BEFORE ${PROJECT_SOURCE_DIR})

# Subdirectories
################

if(BUILD_EXAMPLES)
   add_subdirectory(examples)
endif()

if(BUILD_TESTING)
   add_subdirectory(tests)
endif()

add_subdirectory(doc)

add_subdirectory(libviennacl)

# Install
#########

install(DIRECTORY viennacl ${CMAKE_CURRENT_BINARY_DIR}/viennacl
   DESTINATION ${INSTALL_INCLUDE_DIR} COMPONENT dev
   FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp")

=== doc/CMakeLists.txt ===
if(BUILD_DOXYGEN_DOCS)
   configure_file(Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
   add_custom_command(OUTPUT
      ${CMAKE_CURRENT_BINARY_DIR}/doxygen/html/index.html
      COMMAND ${DOXYGEN_EXECUTABLE}
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      VERBATIM)
   # Runs only once
   add_custom_target(apidoc-all ALL
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doxygen/html/index.html)
   # For manual updates
   add_custom_target(apidoc
      COMMAND ${DOXYGEN_EXECUTABLE}
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      VERBATIM)
endif()

if(BUILD_MANUAL)
   set(MANUAL_SRCS
      manual/algorithms.tex
      manual/benchmarks.tex
      manual/changelogs.tex
      manual/contributors.tex
      manual/cover.tex
      manual/custom-contexts.tex
      manual/custom-kernels.tex
      manual/design.tex
      manual/figures/logo_px200.eps
      manual/figures/matvec2.eps
      manual/figures/note.eps
      manual/figures/solver.eps
      manual/figures/tip.eps
      manual/figures/TU_Signet_CMYK.eps
      manual/IEEEtran_v1.13.bst
      manual/additional-algorithms.tex
      manual/installation.tex
      manual/introduction.tex
      manual/keywords.tex
      manual/license.tex
      manual/multi-device.tex
      manual/operations.tex
      manual/other-libs.tex
      manual/shared-lib.tex
      manual/setup.tex
      manual/structured-matrices.tex
      manual/tuning.tex
      manual/types.tex
      manual/versioning.tex
      manual/viennacl.bib
      manual/viennacl.tex)

   set(MANUAL_OBJS
      "${CMAKE_CURRENT_BINARY_DIR}/viennacl.pdf"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.bbl"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.blg"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.dvi"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.idx"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.log"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.out"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.ps"
      "${CMAKE_CURRENT_BINARY_DIR}/manual/viennacl.toc")
   foreach(f IN LISTS MANUAL_SRCS)
      configure_file(${f} ${CMAKE_CURRENT_BINARY_DIR}/${f} COPYONLY)
      if(f MATCHES "(.*)\\.tex$")
         list(APPEND MANUAL_OBJS
            "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_MATCH_1}.aux")
      endif()
   endforeach()

   add_custom_command(OUTPUT ${MANUAL_OBJS}
      COMMAND ${LATEX_COMPILER} viennacl.tex
      COMMAND ${LATEX_COMPILER} viennacl.tex
      COMMAND ${BIBTEX_COMPILER} viennacl
      COMMAND ${LATEX_COMPILER} viennacl.tex
      COMMAND ${BIBTEX_COMPILER} viennacl
      COMMAND ${LATEX_COMPILER} viennacl.tex
      COMMAND ${DVIPS_CONVERTER} -Ppdf -G0 -ta4 viennacl.dvi
      COMMAND ${PS2PDF_CONVERTER} -dPDFSETTINGS=/prepress
         -dCompatibilityLevel=1.3 -dMAxSubsetPct=100 -dSubsetFonts=true
         -dEmbedAllFonts=true -sPAPERSIZE=a4 -dAutoRotatePages=/None
         -dOptimize=true viennacl.ps ../viennacl.pdf
      DEPENDS ${MANUAL_SRCS}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/manual
      COMMENT "Generating manual viennacl.pdf"
      VERBATIM)

   add_custom_target(manual ALL
      DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/viennacl.pdf")
endif()

=== examples/CMakeLists.txt ===
set(EXAMPLES_TESTDATA
   testdata/mat65k.mtx
   testdata/README
   testdata/result65025.txt
   testdata/rhs65025.txt)
foreach(f ${EXAMPLES_TESTDATA})
   configure_file(${f} "${CMAKE_CURRENT_BINARY_DIR}/${f}" COPYONLY)
endforeach()

add_subdirectory(tutorial)
add_subdirectory(autotuner)
add_subdirectory(benchmarks)

=== libviennacl/CMakeLists.txt ===

include_directories(${PROJECT_SOURCE_DIR}/libviennacl/include/)

if(ENABLE_CUDA)

  if(ENABLE_OPENCL)
    set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS} "-DVIENNACL_WITH_OPENCL") #set flags before setting executable!
    cuda_add_library(viennacl SHARED src/backend.cu
                                     src/blas1.cu src/blas1_host.cu src/blas1_cuda.cu src/blas1_opencl.cu
                                     src/blas2.cu src/blas2_host.cu src/blas2_cuda.cu src/blas2_opencl.cu
                                     src/blas3.cu src/blas3_host.cu src/blas3_cuda.cu src/blas3_opencl.cu)
    set_target_properties(viennacl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL -DVIENNACL_WITH_CUDA")
    target_link_libraries(viennacl ${OPENCL_LIBRARIES})
  else(ENABLE_OPENCL)
    cuda_add_library(viennacl SHARED src/backend.cu
                                     src/blas1.cu src/blas1_host.cu src/blas1_cuda.cu
                                     src/blas2.cu src/blas2_host.cu src/blas2_cuda.cu
                                     src/blas3.cu src/blas3_host.cu src/blas3_cuda.cu)
    set_target_properties(viennacl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_CUDA")
  endif(ENABLE_OPENCL)
else(ENABLE_CUDA)
  if(ENABLE_OPENCL)
    add_library(viennacl SHARED src/backend.cpp
                                src/blas1.cpp src/blas1_host.cpp src/blas1_opencl.cpp
                                src/blas2.cpp src/blas2_host.cpp src/blas2_opencl.cpp
                                src/blas3.cpp src/blas3_host.cpp src/blas3_opencl.cpp)
    set_target_properties(viennacl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
    target_link_libraries(viennacl ${OPENCL_LIBRARIES})
  else(ENABLE_OPENCL)
    add_library(viennacl SHARED src/backend.cpp
                                src/blas1.cpp src/blas1_host.cpp
                                src/blas2.cpp src/blas2_host.cpp
                                src/blas3.cpp src/blas3_host.cpp)
  endif(ENABLE_OPENCL)
endif(ENABLE_CUDA)

=== tests/CMakeLists.txt ===

include_directories(${Boost_INCLUDE_DIRS})

# tests with CPU backend
foreach(PROG blas3_prod_float blas3_prod_double blas3_solve_float blas3_solve_double iterators
             global_variables
             matrix_vector matrix_vector_int
             matrix_row_float matrix_row_double matrix_row_int
             matrix_col_float matrix_col_double matrix_col_int
             scalar scheduler_matrix scheduler_matrix_matrix scheduler_matrix_vector scheduler_sparse scheduler_vector sparse
             vector_float vector_double vector_int vector_uint vector_multi_inner_prod
             spmdm)
   add_executable(${PROG}-test-cpu src/${PROG}.cpp)
   target_link_libraries(${PROG}-test-cpu ${Boost_LIBRARIES})
   add_test(${PROG}-cpu ${PROG}-test-cpu)
endforeach(PROG)


# tests with OpenCL backend
if (ENABLE_OPENCL)
  foreach(PROG blas3_prod_float blas3_prod_double blas3_solve_float blas3_solve_double fft iterators
               generator_blas1 generator_blas2 generator_blas3 #generator_segmentation
               global_variables
               matrix_vector matrix_vector_int
               matrix_row_float matrix_row_double matrix_row_int
               matrix_col_float matrix_col_double matrix_col_int
               nmf qr_method
               scalar sparse structured-matrices svd
               vector_float vector_double vector_int vector_uint vector_multi_inner_prod
               spmdm)
     add_executable(${PROG}-test-opencl src/${PROG}.cpp)
     target_link_libraries(${PROG}-test-opencl ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
     add_test(${PROG}-opencl ${PROG}-test-opencl)
     set_target_properties(${PROG}-test-opencl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
  endforeach(PROG)

  include_directories(${PROJECT_SOURCE_DIR}/external)
  add_executable(external_linkage-opencl
                 src/external_1.cpp
                 src/external_2.cpp)
  target_link_libraries(external_linkage-opencl ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
  set_target_properties(external_linkage-opencl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
endif (ENABLE_OPENCL)

# tests with CUDA backend
if (ENABLE_CUDA)
  foreach(PROG blas3_prod_float blas3_prod_double blas3_solve_float blas3_solve_double iterators
               global_variables
               matrix_vector matrix_vector_int
               matrix_row_float matrix_row_double matrix_row_int
               matrix_col_float matrix_col_double matrix_col_int
               scalar sparse
               vector_float vector_double vector_int vector_uint vector_multi_inner_prod
               spmdm)
     cuda_add_executable(${PROG}-test-cuda src/${PROG}.cu)
     target_link_libraries(${PROG}-test-cuda ${Boost_LIBRARIES})
     add_test(${PROG}-cuda ${PROG}-test-cuda)
  endforeach(PROG)

  include_directories(${PROJECT_SOURCE_DIR}/external)
  cuda_add_executable(external_linkage-cuda
                      src/external_1.cu
                      src/external_2.cu)
  target_link_libraries(external_linkage-cuda ${Boost_LIBRARIES})
endif (ENABLE_CUDA)

# test shared library
include_directories(${PROJECT_SOURCE_DIR}/libviennacl/include/)

if(ENABLE_CUDA)
  if(ENABLE_OPENCL)
    set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS} "-DVIENNACL_WITH_OPENCL") #set flags before setting executable!
    cuda_add_executable(libviennacl_blas1-test src/libviennacl_blas1.cu)
    target_link_libraries(libviennacl_blas1-test viennacl ${OPENCL_LIBRARIES})

    cuda_add_executable(libviennacl_blas2-test src/libviennacl_blas2.cu)
    target_link_libraries(libviennacl_blas2-test viennacl ${OPENCL_LIBRARIES})

    cuda_add_executable(libviennacl_blas3-test src/libviennacl_blas3.cu)
    target_link_libraries(libviennacl_blas3-test viennacl ${OPENCL_LIBRARIES})

  else(ENABLE_OPENCL)
    cuda_add_executable(libviennacl_blas1-test src/libviennacl_blas1.cu)
    target_link_libraries(libviennacl_blas1-test viennacl)

    cuda_add_executable(libviennacl_blas2-test src/libviennacl_blas2.cu)
    target_link_libraries(libviennacl_blas2-test viennacl)

    cuda_add_executable(libviennacl_blas3-test src/libviennacl_blas3.cu)
    target_link_libraries(libviennacl_blas3-test viennacl)
  endif(ENABLE_OPENCL)
else(ENABLE_CUDA)
  add_executable(libviennacl_blas1-test src/libviennacl_blas1.cpp)
  add_executable(libviennacl_blas2-test src/libviennacl_blas2.cpp)
  add_executable(libviennacl_blas3-test src/libviennacl_blas3.cpp)
  if(ENABLE_OPENCL)
    set_target_properties(libviennacl_blas1-test PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
    target_link_libraries(libviennacl_blas1-test viennacl ${OPENCL_LIBRARIES})

    set_target_properties(libviennacl_blas2-test PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
    target_link_libraries(libviennacl_blas2-test viennacl ${OPENCL_LIBRARIES})

    set_target_properties(libviennacl_blas3-test PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
    target_link_libraries(libviennacl_blas3-test viennacl ${OPENCL_LIBRARIES})
  else(ENABLE_OPENCL)
    target_link_libraries(libviennacl_blas1-test viennacl)
    target_link_libraries(libviennacl_blas2-test viennacl)
    target_link_libraries(libviennacl_blas3-test viennacl)
  endif(ENABLE_OPENCL)
endif(ENABLE_CUDA)
add_test(libviennacl-blas1 libviennacl_blas1-test)
add_test(libviennacl-blas2 libviennacl_blas2-test)
add_test(libviennacl-blas3 libviennacl_blas3-test)

=== examples/autotuner/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/external)

if (ENABLE_OPENCL)
  include_directories(${PROJECT_SOURCE_DIR}/external/)

  foreach(proc vector-axpy_autotuning dot_autotuning gemv_autotuning gemm_autotuning dump_default_kernels)
    add_executable(${proc} ${proc}.cpp)
    target_link_libraries(${proc} ${OPENCL_LIBRARIES})
    set_target_properties(${proc} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
  endforeach()

endif (ENABLE_OPENCL)

=== examples/benchmarks/CMakeLists.txt ===
# Targets using CPU-based execution
foreach(bench blas3 copy scheduler vector)
   add_executable(${bench}bench-cpu ${bench}.cpp)
endforeach()

if (ENABLE_UBLAS)
    include_directories(${Boost_INCLUDE_DIRS})
    foreach(bench sparse solver)
      add_executable(${bench}bench-cpu ${bench}.cpp)
      target_link_libraries(${bench}bench-cpu ${Boost_LIBRARIES})
    endforeach()
endif (ENABLE_UBLAS)


# Targets using OpenCL
if (ENABLE_OPENCL)

  foreach(bench blas3 copy
          generator_blas1 generator_blas2 generator_blas3
          opencl vector)
    add_executable(${bench}bench-opencl ${bench}.cpp)
    target_link_libraries(${bench}bench-opencl ${OPENCL_LIBRARIES})
    set_target_properties(${bench}bench-opencl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
  endforeach()

  if (ENABLE_UBLAS)
     include_directories(${Boost_INCLUDE_DIRS})
     foreach(bench sparse solver)
       add_executable(${bench}bench-opencl ${bench}.cpp)
       target_link_libraries(${bench}bench-opencl ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
       set_target_properties(${bench}bench-opencl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
     endforeach()
  endif (ENABLE_UBLAS)

endif (ENABLE_OPENCL)

# Targets using CUDA
if (ENABLE_CUDA)

  foreach(bench blas3 copy vector)
     cuda_add_executable(${bench}bench-cuda ${bench}.cu)
  endforeach()

  if (ENABLE_UBLAS)
     include_directories(${Boost_INCLUDE_DIRS})
     foreach(bench sparse solver)
       cuda_add_executable(${bench}bench-cuda ${bench}.cu)
      target_link_libraries(${bench}bench-cuda ${Boost_LIBRARIES})
     endforeach()
  endif (ENABLE_UBLAS)

endif (ENABLE_CUDA)


# IF(CMAKE_COMPILER_IS_GNUCXX)
   #ADD_DEFINITIONS(-Wall -pedantic -O0 -g)
#   ADD_DEFINITIONS(-Wall -pedantic -O3)
# ENDIF(CMAKE_COMPILER_IS_GNUCXX)

=== examples/tutorial/CMakeLists.txt ===



#
# Part 1: Tutorials which work without OpenCL as well:
#
foreach(tut bandwidth-reduction blas1 scheduler wrap-host-buffer)
   add_executable(${tut} ${tut}.cpp)
   if (ENABLE_OPENCL)
     target_link_libraries(${tut} ${OPENCL_LIBRARIES})
     set_target_properties(${tut} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
   endif (ENABLE_OPENCL)
endforeach()

if(ENABLE_UBLAS)
   include_directories(${Boost_INCLUDE_DIRS})
   foreach(tut blas2 blas3 iterative-ublas lanczos least-squares matrix-range power-iter qr sparse vector-range)
      add_executable(${tut} ${tut}.cpp)
      target_link_libraries(${tut} ${Boost_LIBRARIES})
      if (ENABLE_OPENCL)
        target_link_libraries(${tut} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
        set_target_properties(${tut} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
      endif (ENABLE_OPENCL)
   endforeach()
endif()

if(ENABLE_EIGEN)
   include_directories(${EIGEN_INCLUDE_DIR})
   add_executable(iterative-eigen     iterative-eigen.cpp)
   add_executable(eigen-with-viennacl eigen-with-viennacl.cpp)
   if (ENABLE_OPENCL)
     target_link_libraries(eigen-with-viennacl ${OPENCL_LIBRARIES})
     set_target_properties(eigen-with-viennacl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
   endif (ENABLE_OPENCL)
endif()

if(ENABLE_MTL4)
   foreach(tut iterative-mtl4 mtl4-with-viennacl)
     add_executable(${tut} ${tut}.cpp)
     if (ENABLE_OPENCL)
       target_link_libraries(${tut} ${OPENCL_LIBRARIES})
       set_target_properties(${tut} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
     endif (ENABLE_OPENCL)
   endforeach()
endif()



#
# Part 2: Tutorials which work only with OpenCL enabled:
#
if (ENABLE_OPENCL)
  foreach(tut custom-kernels custom-context fft viennacl-info)
    add_executable(${tut} ${tut}.cpp)
    target_link_libraries(${tut} ${OPENCL_LIBRARIES})
    set_target_properties(${tut} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
  endforeach()

  if(ENABLE_UBLAS)
    include_directories(${Boost_INCLUDE_DIRS})
    foreach(tut amg iterative multithreaded multithreaded_cg spai structured-matrices)
        add_executable(${tut} ${tut}.cpp)
        target_link_libraries(${tut} ${Boost_LIBRARIES})
        if (ENABLE_OPENCL)
          target_link_libraries(${tut} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
          set_target_properties(${tut} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
        endif (ENABLE_OPENCL)
    endforeach()
  endif()
endif (ENABLE_OPENCL)


#
# Part 3: Tutorials with CUDA support
#

if (ENABLE_CUDA)
  foreach(tut blas1 wrap-cuda-buffer)
    cuda_add_executable(${tut}-cuda ${tut}.cu)
  endforeach()

  if(ENABLE_UBLAS)
    include_directories(${Boost_INCLUDE_DIRS})
    foreach(tut blas2 blas3 iterative least-squares matrix-range power-iter qr sparse vector-range)
        cuda_add_executable(${tut}-cuda ${tut}.cu)
        target_link_libraries(${tut}-cuda ${Boost_LIBRARIES})
    endforeach()
  endif()

endif (ENABLE_CUDA)

#
# Part 4: Tutorials on using the shared C-library
#

include_directories(${PROJECT_SOURCE_DIR}/libviennacl/include/)

if(ENABLE_CUDA)
  if(ENABLE_OPENCL)
    set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS} "-DVIENNACL_WITH_OPENCL") #set flags before setting executable!
    cuda_add_executable(libviennacl-tutorial libviennacl.cu)
    #set_target_properties(libviennacl-tutorial PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL -DVIENNACL_WITH_CUDA")
    target_link_libraries(libviennacl-tutorial viennacl ${OPENCL_LIBRARIES})
  else(ENABLE_OPENCL)
    cuda_add_executable(libviennacl-tutorial libviennacl.cu)
    target_link_libraries(libviennacl-tutorial viennacl)
  endif(ENABLE_OPENCL)
else(ENABLE_CUDA)
  add_executable(libviennacl-tutorial libviennacl.cpp)
  if(ENABLE_OPENCL)
    set_target_properties(libviennacl-tutorial PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
    target_link_libraries(libviennacl-tutorial viennacl ${OPENCL_LIBRARIES})
  else(ENABLE_OPENCL)
    target_link_libraries(libviennacl-tutorial viennacl)
  endif(ENABLE_OPENCL)
endif(ENABLE_CUDA)

=== debian/changelog ===
viennacl (1.5.1-1) unstable; urgency=medium

  [ Toby Smithe ]

  * [d19020e] New upstream version 1.5.1
  * Update debian/control:
    + add myself to Uploaders;
    + update Standards-Version to 3.9.5;
    + move out of contrib.

  [ Michael Wild ]

  * [c10d1b6] Removed patches/*, everything fixed in new upstream
  * [ac8d81b] Exclude editor backup file from dh_clean
  * [8cf95b2] Don't auto-generate changelog anymore, upstream added it
  * [1e6e73c] Remove get-orig-source target; upstream is clean
  * [7975906] Remove erronous DMUA entry
  * [a5a30b6] New upstream version 1.3.0
  * [2db3b5a] Update DH_ALWAYS_EXCLUDE for 1.3.0
  * [0f8c6fd] Configure debian/libviennacl-doc.docs in
              override_dh_auto_configure
  * [b328905] Remove Ubuntu-specific include-directory
  * [359dede] Remove unused build-deps: poppler-utils, asciidoc, lynx
  * [a43ff39] Add 0001-Add-virtual-dtor-to-abstract-result_of-class.patch
  * [a86c820] Add 0002-Fix-declaration-order-of-prod_impl-trans_prod_impl.patch
  * [3456f0e] Add 0003-Generate-kernel-sources-in-build-tree.patch
  * [c70a562] Install headers from DESTDIR instead from source
  * [90ec80a] Cleanup and comments in debian/rules
  * [a99add4] Disable python-support in debian/rules
  * [35a31dc] Configure git-dch to include hashes in the entries
  * [afa8f8d] Standardize Vcs-Git URL
  * [914f232] Upload to experimental because of Wheezy freeze

  [ Anton Gladky ]

  * [35433e9] Set compat level 9.
  * [33bf385] Enable parallel build.

 -- Toby Smithe <tsmithe@ubuntu.com>  Wed, 19 Feb 2014 16:12:04 +0000

viennacl (1.2.0-2) unstable; urgency=low

  * [432b5df] Change debian branch to debian/1.2.0
  * [815d6d8] Fix declaration order of prod_impl() and trans_prod_impl()
    - Added d/p/0004-Fix-declaration-order-of-prod_impl-trans_prod_impl.patch
    (Closes: 682410)

 -- Michael Wild <themiwi@users.sourceforge.net>  Fri, 27 Jul 2012 22:24:56 +0200

=== debian/control ===
Source: viennacl
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Michael Wild <themiwi@users.sourceforge.net>, Toby Smithe <tsmithe@ubuntu.com>, Anton Gladky <gladk@debian.org>
Build-Depends: debhelper (>= 9), cmake (>= 2.8), libboost-filesystem-dev,
 libboost-chrono-dev, libboost-date-time-dev, libboost-serialization-dev,
 libboost-thread-dev, texlive-latex-extra, texlive-latex-recommended,
 texlive-fonts-recommended, texlive-pstricks, ghostscript, doxygen, 
 opencl-headers, libopencl1
Standards-Version: 3.9.5
Homepage: http://viennacl.sourceforge.net
Vcs-Git: git://git.debian.org/debian-science/packages/viennacl.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/viennacl.git

Package: libviennacl-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends}, opencl-headers, libopencl1
Suggests: libeigen2-dev, libboost-dev, libviennacl-doc
Description: Scientific computing library written in C++ based on OpenCL
 The Vienna Computing Library (ViennaCL) is a scientific computing library
 written in C++ and based on OpenCL. It allows simple, high-level access to the
 vast computing resources available on parallel architectures such as GPUs and
 is primarily focused on common linear algebra operations (BLAS levels 1, 2 and
 3) and the solution of large systems of equations by means of iterative
 methods with optional preconditioner.
 .
 ViennaCL is header-only with no binary library and projects using it only need
 to link against a conforming OpenCL implementation.

Package: libviennacl-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libviennacl-dev
Description: ViennaCL API and user documentation
 The Vienna Computing Library (ViennaCL) is a scientific computing library
 written in C++ and based on OpenCL. It allows simple, high-level access to the
 vast computing resources available on parallel architectures such as GPUs and
 is primarily focused on common linear algebra operations (BLAS levels 1, 2 and
 3) and the solution of large systems of equations by means of iterative
 methods with optional preconditioner.
 .
 This package contains the Doxygen-generated source code and the user
 documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Utility to get a literal space in GNU Make
space :=
space +=

# Ignore spurious editor backup files in orig tarball
export DH_ALWAYS_EXCLUDE
override DH_ALWAYS_EXCLUDE := $(subst $(space),:,$(strip $(DH_ALWAYS_EXCLUDE) \
	auxiliary/nmf/align1/el_wise_mul_div.cl~                              \
	auxiliary/nmf/align1/sub_wise.cl~                                     \
	examples/tutorial/iterative-ublas.cpp~                                \
	viennacl/linalg/lanczos.hpp~                                          \
	))

BUILDDIR := obj-$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# Catch-all rule
%:
	dh $@ --without python-support --parallel

override_dh_auto_configure:
	rm -rf CL
	sed 's|@BUILDDIR@|$(BUILDDIR)|g' debian/libviennacl-doc.docs.in >     \
	  debian/libviennacl-doc.docs
	dh_auto_configure

override_dh_auto_test: $(BUILDDIR)/test_compute_capability
	if $(BUILDDIR)/test_compute_capability; then                          \
	  dh_auto_test;                                                       \
	else                                                                  \
	  echo '== SKIPPING TESTS BECAUSE NO OPENCL CAPABILITY FOUND ==' >&2; \
	fi

# Utility program to determine compute-capability of the build host
$(BUILDDIR)/test_compute_capability: debian/test_compute_capability.c
	gcc -o $@ `dpkg-buildflags --get CFLAGS`                              \
	  `dpkg-buildflags --get LDFLAGS` $^ -lOpenCL

=== debian/watch ===
version=3

http://sf.net/viennacl/ViennaCL-(\d.*)-src\.tar\.gz

## viennacl 1.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,7 @@
 
 set(VERSION_MAJOR 1)
 set(VERSION_MINOR 5)
-set(VERSION_PATCH 1)
+set(VERSION_PATCH 2)
 set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

=== debian/changelog ===
viennacl (1.5.2-2) unstable; urgency=medium

  [ Graham Inggs ]
  * [6fb521e] Add ocl-icd-opencl-dev | opencl-dev to BD.
              (Closes: #760232, #761528)

  [ Anton Gladky ]
  * [bee9ecc] Fix license name.
  * [8934d52] Set canonical VCS-field.
  * [029cb4e] Use wrap-and-sort.
  * [9fecf0c] Add autopkgtest.

 -- Anton Gladky <gladk@debian.org>  Thu, 18 Sep 2014 23:07:51 +0200

viennacl (1.5.2-1) unstable; urgency=medium

  * [15d0b5a] New upstream version 1.5.2
    + bug fixes and performance improvements

 -- Toby Smithe <tsmithe@ubuntu.com>  Fri, 16 May 2014 11:43:59 +0100

=== debian/control ===
Source: viennacl
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Michael Wild <themiwi@users.sourceforge.net>,
 Toby Smithe <tsmithe@ubuntu.com>,
 Anton Gladky <gladk@debian.org>
Build-Depends:
 cmake (>= 2.8),
 debhelper (>= 9),
 doxygen,
 ghostscript,
 libboost-chrono-dev,
 libboost-date-time-dev,
 libboost-filesystem-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 ocl-icd-opencl-dev | opencl-dev,
 texlive-fonts-recommended,
 texlive-latex-extra,
 texlive-latex-recommended,
 texlive-pstricks
Standards-Version: 3.9.5
XS-Testsuite: autopkgtest
Homepage: http://viennacl.sourceforge.net
Vcs-Git: git://anonscm.debian.org/debian-science/packages/viennacl.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/viennacl.git

Package: libviennacl-dev
Architecture: all
Section: libdevel
Depends:
 ocl-icd-opencl-dev | opencl-dev,
 ${misc:Depends}
Suggests:
 libboost-dev,
 libeigen2-dev,
 libviennacl-doc
Description: Scientific computing library written in C++ based on OpenCL
 The Vienna Computing Library (ViennaCL) is a scientific computing library
 written in C++ and based on OpenCL. It allows simple, high-level access to the
 vast computing resources available on parallel architectures such as GPUs and
 is primarily focused on common linear algebra operations (BLAS levels 1, 2 and
 3) and the solution of large systems of equations by means of iterative
 methods with optional preconditioner.
 .
 ViennaCL is header-only with no binary library and projects using it only need
 to link against a conforming OpenCL implementation.

Package: libviennacl-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends}
Suggests:
 libviennacl-dev
Description: ViennaCL API and user documentation
 The Vienna Computing Library (ViennaCL) is a scientific computing library
 written in C++ and based on OpenCL. It allows simple, high-level access to the
 vast computing resources available on parallel architectures such as GPUs and
 is primarily focused on common linear algebra operations (BLAS levels 1, 2 and
 3) and the solution of large systems of equations by means of iterative
 methods with optional preconditioner.
 .
 This package contains the Doxygen-generated source code and the user
 documentation.

## viennacl 1.7.1%2Bdfsg1

=== debian/tests/control ===
Tests: build1 build2 build3
Restrictions: allow-stderr
Depends: libviennacl-dev, build-essential

## viennacl 1.7.1+dfsg1

=== CMakeLists.txt ===
# Project setup
###############

cmake_minimum_required(VERSION 2.6 FATAL_ERROR)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

project(ViennaCL)


#
# User customizations if CMake does not find Boost or OpenCL
#

# Set boost path here if not found automatically by CMake
#SET(BOOST_ROOT "C:/Program\ Files\ (x86)/boost/boost_1_42")     # adjust this on Windows
#SET(BOOST_ROOT "/opt/local/include")                            # adjust this on MacOS or Linux


# Common options - There is usually no need to change anything below this line
################

set(VERSION_MAJOR 1)
set(VERSION_MINOR 7)
set(VERSION_PATCH 1)
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# do not build tests by default, since they require Boost
option(BUILD_TESTING "Build the tests " OFF)

include(ViennaCLCommon)


# Set release build:
IF(DEFINED CMAKE_BUILD_TYPE)
 SET (CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}")
ELSE()
 SET (CMAKE_BUILD_TYPE Release)
ENDIF()

# Subdirectories
################

if(BUILD_EXAMPLES)
   add_subdirectory(examples)
endif()

if(BUILD_TESTING)
   add_subdirectory(tests)
endif()

add_subdirectory(libviennacl)


# Install
#########

install(DIRECTORY viennacl "${CMAKE_CURRENT_BINARY_DIR}/viennacl"
   DESTINATION "${INSTALL_INCLUDE_DIR}" COMPONENT dev
   FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp")

=== examples/CMakeLists.txt ===
set(EXAMPLES_TESTDATA
   testdata/mat65k.mtx
   testdata/README
   testdata/result65025.txt
   testdata/rhs65025.txt
   testdata/eigen/nsm1.example
   testdata/eigen/nsm2.example
   testdata/eigen/nsm3.example
   testdata/eigen/symm5.example
   testdata/svd/qr.example
   testdata/svd/wiki.example
   testdata/svd/wiki.qr.example
   testdata/svd/pysvd.example
   testdata/svd/random.example)
foreach(f ${EXAMPLES_TESTDATA})
   configure_file(${f} "${CMAKE_CURRENT_BINARY_DIR}/${f}" COPYONLY)
endforeach()

add_subdirectory(tutorial)
add_subdirectory(benchmarks)

=== libviennacl/CMakeLists.txt ===
--- 
+++ 
@@ -33,3 +33,8 @@
                                 src/blas3.cpp src/blas3_host.cpp)
   endif(ENABLE_OPENCL)
 endif(ENABLE_CUDA)
+
+# Special linkage for OpenMP under MinGW:
+if(ENABLE_OPENMP AND MINGW)
+   target_link_libraries(viennacl gomp)
+endif(ENABLE_OPENMP AND MINGW)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -2,13 +2,15 @@
 include_directories(${Boost_INCLUDE_DIRS})
 
 # tests with CPU backend
-foreach(PROG blas3_prod_float blas3_prod_double blas3_solve_float blas3_solve_double iterators
+foreach(PROG matrix_product_float matrix_product_double blas3_solve fft_1d fft_2d iterators
              global_variables
+             nmf
+             matrix_convert
              matrix_vector matrix_vector_int
              matrix_row_float matrix_row_double matrix_row_int
              matrix_col_float matrix_col_double matrix_col_int
-             scalar scheduler_matrix scheduler_matrix_matrix scheduler_matrix_vector scheduler_sparse scheduler_vector sparse
-             vector_float vector_double vector_int vector_uint vector_multi_inner_prod
+             scalar scheduler_matrix scheduler_matrix_matrix self_assign qr_method qr_method_func scan scheduler_matrix_vector scheduler_sparse scheduler_vector sparse sparse_prod
+             tql vector_convert vector_float_double vector_int vector_uint vector_multi_inner_prod
              spmdm)
    add_executable(${PROG}-test-cpu src/${PROG}.cpp)
    target_link_libraries(${PROG}-test-cpu ${Boost_LIBRARIES})
@@ -18,15 +20,15 @@
 
 # tests with OpenCL backend
 if (ENABLE_OPENCL)
-  foreach(PROG blas3_prod_float blas3_prod_double blas3_solve_float blas3_solve_double fft iterators
-               generator_blas1 generator_blas2 generator_blas3 #generator_segmentation
+  foreach(PROG bisect matrix_product_float matrix_product_double blas3_solve fft_1d fft_2d iterators
                global_variables
+               matrix_convert
                matrix_vector matrix_vector_int
                matrix_row_float matrix_row_double matrix_row_int
                matrix_col_float matrix_col_double matrix_col_int
-               nmf qr_method
-               scalar sparse structured-matrices svd
-               vector_float vector_double vector_int vector_uint vector_multi_inner_prod
+               nmf qr_method qr_method_func scan
+               scalar self_assign sparse sparse_prod structured-matrices svd tql
+               vector_convert vector_float_double vector_int vector_uint vector_multi_inner_prod
                spmdm)
      add_executable(${PROG}-test-opencl src/${PROG}.cpp)
      target_link_libraries(${PROG}-test-opencl ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
@@ -44,13 +46,14 @@
 
 # tests with CUDA backend
 if (ENABLE_CUDA)
-  foreach(PROG blas3_prod_float blas3_prod_double blas3_solve_float blas3_solve_double iterators
+  foreach(PROG bisect matrix_product_float matrix_product_double blas3_solve fft_1d fft_2d iterators
                global_variables
+               matrix_convert
                matrix_vector matrix_vector_int
                matrix_row_float matrix_row_double matrix_row_int
-               matrix_col_float matrix_col_double matrix_col_int
-               scalar sparse
-               vector_float vector_double vector_int vector_uint vector_multi_inner_prod
+               matrix_col_float matrix_col_double matrix_col_int nmf
+               scalar self_assign sparse qr_method qr_method_func scan sparse_prod tql
+               vector_convert vector_float_double vector_int vector_uint vector_multi_inner_prod
                spmdm)
      cuda_add_executable(${PROG}-test-cuda src/${PROG}.cu)
      target_link_libraries(${PROG}-test-cuda ${Boost_LIBRARIES})
@@ -67,8 +70,8 @@
 # test shared library
 include_directories(${PROJECT_SOURCE_DIR}/libviennacl/include/)
 
-if(ENABLE_CUDA)
-  if(ENABLE_OPENCL)
+if (ENABLE_CUDA)
+  if (ENABLE_OPENCL)
     set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS} "-DVIENNACL_WITH_OPENCL") #set flags before setting executable!
     cuda_add_executable(libviennacl_blas1-test src/libviennacl_blas1.cu)
     target_link_libraries(libviennacl_blas1-test viennacl ${OPENCL_LIBRARIES})
@@ -88,12 +91,12 @@
 
     cuda_add_executable(libviennacl_blas3-test src/libviennacl_blas3.cu)
     target_link_libraries(libviennacl_blas3-test viennacl)
-  endif(ENABLE_OPENCL)
+  endif (ENABLE_OPENCL)
 else(ENABLE_CUDA)
   add_executable(libviennacl_blas1-test src/libviennacl_blas1.cpp)
   add_executable(libviennacl_blas2-test src/libviennacl_blas2.cpp)
   add_executable(libviennacl_blas3-test src/libviennacl_blas3.cpp)
-  if(ENABLE_OPENCL)
+  if (ENABLE_OPENCL)
     set_target_properties(libviennacl_blas1-test PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
     target_link_libraries(libviennacl_blas1-test viennacl ${OPENCL_LIBRARIES})
 
@@ -106,8 +109,8 @@
     target_link_libraries(libviennacl_blas1-test viennacl)
     target_link_libraries(libviennacl_blas2-test viennacl)
     target_link_libraries(libviennacl_blas3-test viennacl)
-  endif(ENABLE_OPENCL)
-endif(ENABLE_CUDA)
+  endif (ENABLE_OPENCL)
+endif (ENABLE_CUDA)
 add_test(libviennacl-blas1 libviennacl_blas1-test)
 add_test(libviennacl-blas2 libviennacl_blas2-test)
 add_test(libviennacl-blas3 libviennacl_blas3-test)

=== examples/benchmarks/CMakeLists.txt ===
# Targets using CPU-based execution
foreach(bench dense_blas scheduler)
   add_executable(${bench}-bench-cpu ${bench}.cpp)
endforeach()

if (ENABLE_UBLAS)
    include_directories(${Boost_INCLUDE_DIRS})
    foreach(bench sparse solver direct_solve)
      add_executable(${bench}-bench-cpu ${bench}.cpp)
      target_link_libraries(${bench}-bench-cpu ${Boost_LIBRARIES})
    endforeach()
endif (ENABLE_UBLAS)


# Targets using OpenCL
if (ENABLE_OPENCL)

  foreach(bench dense_blas opencl)
    add_executable(${bench}-bench-opencl ${bench}.cpp)
    target_link_libraries(${bench}-bench-opencl ${OPENCL_LIBRARIES})
    set_target_properties(${bench}-bench-opencl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
  endforeach()

  if (ENABLE_UBLAS)
     include_directories(${Boost_INCLUDE_DIRS})
     foreach(bench sparse solver direct_solve)
       add_executable(${bench}-bench-opencl ${bench}.cpp)
       target_link_libraries(${bench}-bench-opencl ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
       set_target_properties(${bench}-bench-opencl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
     endforeach()
  endif (ENABLE_UBLAS)

endif (ENABLE_OPENCL)

# Targets using CUDA
if (ENABLE_CUDA)

  foreach(bench dense_blas direct_solve)
     cuda_add_executable(${bench}-bench-cuda ${bench}.cu)
  endforeach()

  if (ENABLE_UBLAS)
     include_directories(${Boost_INCLUDE_DIRS})
     foreach(bench sparse solver)
       cuda_add_executable(${bench}-bench-cuda ${bench}.cu)
      target_link_libraries(${bench}-bench-cuda ${Boost_LIBRARIES})
     endforeach()
  endif (ENABLE_UBLAS)

endif (ENABLE_CUDA)


# IF(CMAKE_COMPILER_IS_GNUCXX)
   #ADD_DEFINITIONS(-Wall -pedantic -O0 -g)
#   ADD_DEFINITIONS(-Wall -pedantic -O3)
# ENDIF(CMAKE_COMPILER_IS_GNUCXX)

=== examples/tutorial/CMakeLists.txt ===



#
# Part 1: Tutorials which work without OpenCL as well:
#
foreach(tut amg bandwidth-reduction blas1 fft iterative-custom matrix-free nmf scheduler wrap-host-buffer)
   add_executable(${tut} ${tut}.cpp)
   if (ENABLE_OPENCL)
     target_link_libraries(${tut} ${OPENCL_LIBRARIES})
     set_target_properties(${tut} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
   endif (ENABLE_OPENCL)
endforeach()

if (ENABLE_UBLAS)
   include_directories(${Boost_INCLUDE_DIRS})
   foreach(tut blas2 blas3 iterative iterative-ublas lanczos least-squares matrix-range power-iter qr sparse qr_method tql2 vector-range)
      add_executable(${tut} ${tut}.cpp)
      target_link_libraries(${tut} ${Boost_LIBRARIES})
      if (ENABLE_OPENCL)
        target_link_libraries(${tut} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
        set_target_properties(${tut} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
      endif (ENABLE_OPENCL)
   endforeach()
endif ()

if (ENABLE_ARMADILLO)
   include_directories(${ARMADILLO_INCLUDE_DIR})
   add_executable(iterative-armadillo     iterative-armadillo.cpp)
   add_executable(armadillo-with-viennacl armadillo-with-viennacl.cpp)
   if (ENABLE_OPENCL)
     target_link_libraries(armadillo-with-viennacl ${OPENCL_LIBRARIES})
     set_target_properties(armadillo-with-viennacl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
   endif (ENABLE_OPENCL)
endif ()

if (ENABLE_EIGEN)
   include_directories(${EIGEN_INCLUDE_DIR})
   add_executable(iterative-eigen     iterative-eigen.cpp)
   add_executable(eigen-with-viennacl eigen-with-viennacl.cpp)
   if (ENABLE_OPENCL)
     target_link_libraries(eigen-with-viennacl ${OPENCL_LIBRARIES})
     set_target_properties(eigen-with-viennacl PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
   endif (ENABLE_OPENCL)
endif ()

if (ENABLE_MTL4)
   foreach(tut iterative-mtl4 mtl4-with-viennacl)
     add_executable(${tut} ${tut}.cpp)
     if (ENABLE_OPENCL)
       target_link_libraries(${tut} ${OPENCL_LIBRARIES})
       set_target_properties(${tut} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
     endif (ENABLE_OPENCL)
   endforeach()
endif ()



#
# Part 2: Tutorials which work only with OpenCL enabled:
#
if (ENABLE_OPENCL)
  foreach(tut bisect custom-kernels custom-context viennacl-info)
    add_executable(${tut} ${tut}.cpp)
    target_link_libraries(${tut} ${OPENCL_LIBRARIES})
    set_target_properties(${tut} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
  endforeach()

  if (ENABLE_UBLAS)
    include_directories(${Boost_INCLUDE_DIRS})
    foreach(tut multithreaded multithreaded_cg spai structured-matrices)
        add_executable(${tut} ${tut}.cpp)
        target_link_libraries(${tut} ${Boost_LIBRARIES})
        if (ENABLE_OPENCL)
          target_link_libraries(${tut} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
          set_target_properties(${tut} PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
        endif (ENABLE_OPENCL)
    endforeach()
  endif ()
endif (ENABLE_OPENCL)


#
# Part 3: Tutorials with CUDA support
#

if (ENABLE_CUDA)
  foreach(tut amg blas1 fft iterative-custom matrix-free nmf wrap-cuda-buffer)
    cuda_add_executable(${tut}-cuda ${tut}.cu)
  endforeach()
  cuda_add_executable(custom-cuda  custom-cuda.cu)  # would otherwise result in custom-cuda-cuda

  if (ENABLE_UBLAS)
    include_directories(${Boost_INCLUDE_DIRS})
    foreach(tut bisect blas2 blas3 iterative least-squares matrix-range power-iter qr qr_method sparse vector-range tql2 )
        cuda_add_executable(${tut}-cuda ${tut}.cu)
        target_link_libraries(${tut}-cuda ${Boost_LIBRARIES})
    endforeach()
  endif ()

endif (ENABLE_CUDA)

#
# Part 4: Tutorials on using the shared C-library
#

include_directories(${PROJECT_SOURCE_DIR}/libviennacl/include/)

if (ENABLE_CUDA)
  if (ENABLE_OPENCL)
    set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS} "-DVIENNACL_WITH_OPENCL") #set flags before setting executable!
    cuda_add_executable(libviennacl-tutorial libviennacl.cu)
    #set_target_properties(libviennacl-tutorial PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL -DVIENNACL_WITH_CUDA")
    target_link_libraries(libviennacl-tutorial viennacl ${OPENCL_LIBRARIES})
  else(ENABLE_OPENCL)
    cuda_add_executable(libviennacl-tutorial libviennacl.cu)
    target_link_libraries(libviennacl-tutorial viennacl)
  endif (ENABLE_OPENCL)
else(ENABLE_CUDA)
  add_executable(libviennacl-tutorial libviennacl.cpp)
  if (ENABLE_OPENCL)
    set_target_properties(libviennacl-tutorial PROPERTIES COMPILE_FLAGS "-DVIENNACL_WITH_OPENCL")
    target_link_libraries(libviennacl-tutorial viennacl ${OPENCL_LIBRARIES})
  else(ENABLE_OPENCL)
    target_link_libraries(libviennacl-tutorial viennacl)
  endif (ENABLE_OPENCL)
endif (ENABLE_CUDA)

=== debian/changelog ===
viennacl (1.7.1+dfsg1-6) unstable; urgency=medium

  * Team upload
  * Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@debian.org>  Sun, 04 Oct 2020 12:52:41 +0000

viennacl (1.7.1+dfsg1-5) unstable; urgency=medium

  * [02bf939] Do not install README and changelog in -dev package. (Closes: #901041)
  * [394bb54] Remove changelog-file from -doc
  * [a549661] Update versions in Breaks/Replaces

 -- Anton Gladky <gladk@debian.org>  Mon, 11 Jun 2018 19:57:01 +0200

viennacl (1.7.1+dfsg1-4) unstable; urgency=medium

  * Team upload.
  * [113b0e5] Add Breaks/Replaces for the libviennacl-doc. (Closes: #901041)

 -- Anton Gladky <gladk@debian.org>  Sat, 09 Jun 2018 16:33:26 +0200

viennacl (1.7.1+dfsg1-3) unstable; urgency=medium

  * Team upload.
  * [6d46561] Apply cme fix dpkg (Standards-Version: 4.1.4)
  * [488529c] Set compat-level 11
  * [860b5ae] Remove myself from uploaders
  * [09dd8a8] Fix path to docs

 -- Anton Gladky <gladk@debian.org>  Thu, 07 Jun 2018 20:37:14 +0200

viennacl (1.7.1+dfsg1-2) unstable; urgency=medium

  * [1135942] Update d/gbp.conf.
  * [b6bf1f9] Move libboost-dev as a dependency of libviennacl-dev.
  * [3e37d8e] Apply cme fix dpkg.

 -- Anton Gladky <gladk@debian.org>  Sun, 04 Sep 2016 08:07:26 +0200

viennacl (1.7.1+dfsg1-1) unstable; urgency=medium

  * [7cbbc94] Update d/watch.
  * [fa23c51] Add Files-Excluded to d/copyright.
  * [4ff9269] Use packaged jquery.js
  * [146f730] Remove unused d/patch.
  * [49e9931] New upstream version 1.7.1+dfsg1
  * [678e017] Use simpler doc-file.
  * [932026d] Apply cme fix dpkg.
  * [f9402fb] Fix duplicated licenses in d/copyright.

 -- Anton Gladky <gladk@debian.org>  Mon, 25 Jan 2016 10:53:04 +0100

=== debian/control ===
Source: viennacl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Michael Wild <themiwi@users.sourceforge.net>,
           Toby Smithe <tsmithe@ubuntu.com>
Section: science
Testsuite: autopkgtest
Priority: optional
Build-Depends: cmake,
               debhelper (>= 11~),
               doxygen,
               ghostscript,
               libboost-chrono-dev,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-serialization-dev,
               libboost-thread-dev,
               ocl-icd-opencl-dev | opencl-dev,
               texlive-fonts-recommended,
               texlive-latex-extra,
               texlive-latex-recommended,
               texlive-pstricks
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/science-team/viennacl
Vcs-Git: https://salsa.debian.org/science-team/viennacl.git
Homepage: http://viennacl.sourceforge.net

Package: libviennacl-dev
Architecture: all
Section: libdevel
Depends: ocl-icd-opencl-dev | opencl-dev,
         ${misc:Depends},
         libboost-dev
Suggests: libviennacl-doc
Description: Scientific computing library written in C++ based on OpenCL
 The Vienna Computing Library (ViennaCL) is a scientific computing library
 written in C++ and based on OpenCL. It allows simple, high-level access to the
 vast computing resources available on parallel architectures such as GPUs and
 is primarily focused on common linear algebra operations (BLAS levels 1, 2 and
 3) and the solution of large systems of equations by means of iterative
 methods with optional preconditioner.
 .
 ViennaCL is header-only with no binary library and projects using it only need
 to link against a conforming OpenCL implementation.

Package: libviennacl-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Breaks: libviennacl-dev ( << 1.7.1+dfsg1-5)
Replaces: libviennacl-dev ( << 1.7.1+dfsg1-5)
Suggests: libviennacl-dev
Description: ViennaCL API and user documentation
 The Vienna Computing Library (ViennaCL) is a scientific computing library
 written in C++ and based on OpenCL. It allows simple, high-level access to the
 vast computing resources available on parallel architectures such as GPUs and
 is primarily focused on common linear algebra operations (BLAS levels 1, 2 and
 3) and the solution of large systems of equations by means of iterative
 methods with optional preconditioner.
 .
 This package contains the Doxygen-generated source code and the user
 documentation.

=== debian/watch ===
version=3
opts=repacksuffix=+dfsg1,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb|-dfsg)\d*$// \
http://sf.net/viennacl/ViennaCL-(\d\S*)-src\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
